<template>
  <div class="token-warning-section">
    <p v-if="selectedToken.holderCount !== null">
      {{ symbol }} token has
      <span>{{ selectedToken.holderCount }}</span> holders and
      <span>{{ selectedToken.txsCount }}</span> transfers. It has
      <span class="no-blue-mark" v-if="selectedToken.hasBlueTick === false"
        >not</span
      >
      received
      <a
        href="https://etherscancom.freshdesk.com/support/solutions/articles/35000082730-the-blue-checkmark"
        target="_blank"
        >a blue checkmark</a
      >
      on Etherscan.io
    </p>
    <p v-if="tokenCount > 1" class="multiple-token-warning">
      There are
      <strong>{{ tokenCount }}</strong> tokens with same symbol
      <strong>{{ symbol }}</strong
      >. Please make sure you are selecting the correct token.
    </p>
  </div>
</template>

<script>
import Vue from 'vue'
import { mapGetters, mapActions } from 'vuex'
import axios from 'axios'
import moment from 'moment'
import config from '../config'
import {
  getWeb3,
  getWeb3Metamask,
  getBalance,
  getTokenBalance,
  getAllListedToken,
  getETHToUSDPrice,
  getExchangeAddress,
  estimateGas,
  createNewExchange,
  metamaskCreateNewExchange
} from '../assets/js/utils'
export default {
  components: {},
  data: function () {
    return {
      summary: null
    }
  },
  props: ['symbol', 'tokenAddress'],
  computed: {
    ...mapGetters({
      getAccount: 'account/getAccount',
      getActiveToken: 'getActiveToken',
      getActiveTokenAddress: 'getActiveTokenAddress',
      getSummary: 'getSummary',
      getChartInfo: 'getChartInfo',
      getAvailableTokenList: 'account/getAvailableTokenList',
      getOwnedTokenList: 'account/getOwnedTokenList',
      getPrice: 'account/getPrice',
      getEthPrice: 'account/getEthPrice'
    }),
    selectedToken: function () {
      let self = this
      let token = this.getAvailableTokenList.find(
        t =>
          t.symbol === this.symbol &&
          t.tokenAddress.toLowerCase() === this.tokenAddress.toLowerCase()
      )
      let foundSummary
      if (token)
        foundSummary = self.getSummary.find(s => s.token_id === token.id)
      if (!foundSummary && token) {
        return {
          holderCount: 0,
          hasBlueTick: false,
          txsCount: 0
        }
      } else if (!foundSummary && !token) {
        let ownedToken = this.getOwnedTokenList.find(
          t => t.symbol === this.symbol
        )
        return {
          holderCount: null,
          hasBlueTick: null,
          txsCount: null
        }
      } else {
        return {
          holderCount: foundSummary.holderCount,
          hasBlueTick: foundSummary.hasBlueTick,
          txsCount: foundSummary.txsCount
        }
      }
    },
    tokenCount () {
      let tokens = this.getAvailableTokenList.filter(
        t => t.symbol === this.symbol
      )
      return tokens.length
    }
  },
  created: async function () {
    let self = this
    let token = this.getAvailableTokenList.find(
      t =>
        t.symbol === this.symbol &&
        t.tokenAddress.toLowerCase() === this.tokenAddress.toLowerCase()
    )
    if (token) {
      this.summary = this.getSummary.find(s => s.token_id === token.id)
    }
    let ethPrice = this.getEthPrice
    if (!ethPrice) {
      ethPrice = await getETHToUSDPrice()
    }
    this.ethToUsd = ethPrice
  },
  methods: {}
}
</script>

<style>
.token-warning-section {
  width: 90%;
  height: auto;
  max-width: 500px;
  margin: 0 auto;
  text-align: left;
  font-size: 13px;
  font-weight: normal;
  line-height: 1.6;
  margin: 0px 0px;
}
.token-warning-section p {
  margin: 0;
  font-size: 11px;
  color: #333;
  margin: 5px 0px;
}
.token-warning-section .multiple-token-warning {
  color: #dc7b18;
  font-style: italic;
}
.token-warning-section p span {
  font-weight: bold;
}
.token-warning-section p a:hover {
  text-decoration: none;
}
.no-blue-mark {
  font-style: italic;
}
</style>
